;#######################################################################
;#                                                                     #
;#                        SERVE2.SCE                                   #
;#                                                                     #
;#  CONTENTS:                                                          #
;#     parameters:                                                     #
;#        scenario:  serve                                             #
;#          steps:  getting-order, serve-order                         #
;#                                                                     #
;#######################################################################



(defparameter getting-order 
  (make-instance 'mystep
;; Displays messages telling the user that their waiter have left to get their
;; order.
		 :name "getting-order"
		 :my-condition (spscorec :sc 1) 
		 
		 :my-action #'(lambda 
				(self restaurant)
;; only display a messag if there are items to get
				
				(cond  
				 ((or (not 
				       (eq (num-drinks (order-pad restaurant)
						       ) 0))
				      (not (eq (food (order-pad restaurant)) 0)
					   )
				      (not (eq (num-dessert 
						(order-pad restaurant)) 0)))  
				  (say (waiter restaurant) "~%~a

Your waiter has left to get your order...

" (random-pick be-right-back))
  
                
				  (wait 5)))
				)))

(defparameter serve-order 
  (make-instance 'mystep
;;List what the waiter has brought.
		 
		 :name "serve-order"
		 :my-condition (lambdac #'(lambda (restaurant mystep)
					    (prev-step-matches
					     restaurant '("getting-order") 2)))
		 :my-action #'(lambda (self restaurant)
             
				(cond ((not (eq (num-drinks 
						 (order-pad restaurant)) 0))
				       (cond ((eq (num-drinks 
						   (order-pad restaurant)) 1)
					      (say (waiter restaurant) 
						   "~%Here is your ~a." 
						   (reference-name 
						    (car (drink-items 
							  (order-pad 
							   restaurant))))))
					     (t (say (waiter restaurant) 
						     "~%Here is your")
						(loop for i from 0 to 
						      (- (num-drinks 
							  (order-pad 
							   restaurant)) 2) do
							   (say 
							    (waiter restaurant)
							    " ~a, " 
							    (reference-name 
							     (nth i 
								  (drink-items
								   (order-pad 
								    restaurant)
								   )))))
						(say (waiter restaurant) 
						     " and your ~a. " 
						     (reference-name 
						      (nth (- 
							    (num-drinks 
							     (order-pad 
							      restaurant)) 
							    1) 
							   (drink-items 
							    (order-pad 
							     restaurant)))))
               
						))))
				(setf (num-drinks (order-pad restaurant)) 0)
   
				(cond ((not 
					(eq (food (order-pad restaurant)) 0))
             
				       (cond 
					((eq (food (order-pad restaurant)) 1)
					 (say (waiter restaurant) 
					      "~%Here you go, your ~a." 
					      (reference-name 
					       (car (main-course 
						     (order-pad restaurant))
						    ))))
					(t (say (waiter restaurant) 
						"~%Here you are, your")
					   (loop for i from 0 to 
						 (- (food 
						     (order-pad restaurant)) 2)
						 do
						 (say (waiter restaurant) 
						      " ~a, " (reference-name 
							       (nth i 
								   (main-course
								    (order-pad
								     restaurant
								     ))))))
					   (say (waiter restaurant) 
						" and your ~a. " 
						(reference-name 
						 (nth (- 
						       (food 
							(order-pad restaurant)
							) 1) 
						      (main-course 
						       (order-pad restaurant)))
						 ))
					   ))))
				(setf (food (order-pad restaurant)) 0)

				(cond ((not 
					(eq (num-dessert 
					     (order-pad restaurant)) 0))
				       (cond ((eq (num-dessert 
						   (order-pad restaurant)) 1)
					      (say (waiter restaurant) 
						   "~%Here is your ~a." 
						   (reference-name 
						    (car (dessert-items 
							  (order-pad restaurant
								     ))))))
					     (t (say (waiter restaurant) 
						     "~%Here is your")
						(loop for i from 0 to 
						      (- (num-dessert 
							  (order-pad 
							   restaurant)) 2) do
							   (say (waiter 
								 restaurant) 
								" ~a, "
								(reference-name
								 (nth i 
								(dessert-items
								 (order-pad 
								  restaurant)))
								 )))
						(say (waiter restaurant) 
						     " and your ~a. " 
						     (reference-name 
						      (nth (- (num-dessert 
							       (order-pad 
								restaurant)) 1)
								(dessert-items
								 (order-pad 
								  restaurant)))
							   ))
               
						     ))))
				      (setf (num-dessert 
					     (order-pad restaurant)) 0)
				      )))
               
                 


(defparameter serve  
  (make-instance 'scenario
		 :name "serve"
		 :description "Serve items."
		 :steps (list getting-order serve-order)
		 :my-condition (lambdac #'(lambda (restaurant mystep)
					    (if  (and 
						  (> 0 (num-drinks 
							(order-pad restaurant))
						     ) 
						  (> 0 (food 
							(order-pad restaurant))
						     )
						  (> 0 (num-dessert 
							(order-pad restaurant))
						     ))
						(make-instance 'results
							       :success t)
					      (make-instance 'results
							     :success nil))))
                                    
		 :end-condition 
		 (lambdac #'(lambda (restaurant mystep)
			      (if  
				  (and (eq (num-drinks (order-pad restaurant))
					   0) 
				       (eq 0 (food (order-pad restaurant)))
				       (eq 0 
					   (num-dessert (order-pad restaurant))
					   ))
				  (make-instance 'results
                                                 :success t)
				(make-instance 'results
					       :success nil))))))





                 














