;#######################################################################
;#                                                                     #
;#                       WELCOME.SCE                                   #
;#                                                                     #
;#  CONTENTS:                                                          #
;#     parameters:                                                     #
;#         steps:  hi, fine, too-bad what-section, seat-in-smoking     #
;#                 seat-in-non-smoking, deliver-menu                   #
;#         scenario:  greeting                                         #
;#                                                                     #
;#######################################################################

  
;------------------------------
; Welcome scenario
;------------------------------

  (defparameter hi (make-instance 'mystep
;; This is the first step that is execute.  This just greets the customer.
                        :name "hi"
                        :my-condition (spscorec :sc 2 :nec 
                                 	(notc (historyc "hi")))
                        :my-action #'(lambda (self restaurant)
                                        (say w "~%~a ~a" (random-pick say-hi) 
                                           (random-pick howaya))
                                        (setf (expecting-input 
                                            (waiter restaurant)) t))))

  (defparameter fine (make-instance 'mystep
;;  This is executed if the customer asks how the waiter is.  The waiter will
;; reply something like "I'm fine, thank-you."
                        :name "fine"
                        :input-condition (wordc :nec '(how) 
                                                :sup '(are you things life))
                        :my-condition (notc (historyc "fine"))
                                     
                        :my-action
                        #'(lambda (self restaurant)
                             (say w "~%I'm fine, thank-you.")) ))

(defparameter too-bad (make-instance 'mystep
;; This step is executed if the customer enters something very negative after
;; the hi step.
                         :name "too-bad"
                         :input-condition (phrasec (list anystring 
                                                      (make-instance 'pair 
                                                         :head 'no
                                                         :tail 'negation) 
                                                      :nec '(terrible)))
                         :my-condition (spscorec :sc 3 :nec 
                                          (lambdac #'(lambda (rest mystep)
                                          (if (binding-value mystep 'negation )
                                                (make-instance 'results 
                                                       :success nil)
                                                (make-instance 'results 
                                                       :success t)))))
                         :my-action
                         #'(lambda (self restaurant)
                              (say w "~%~a" (random-pick sorry-to-hear))) ))

(defparameter what-section (make-instance 'mystep
;;  This is where the waiter ask what section the customer would like to sit
;; in.
                 :name "what-section"
                 :my-condition (spscorec :sc 2
                                   :nec (andc :nec (list
                                          (historyc "hi")
                                          (notc 
                                             (wordc :nec '(orderable-item))))))
                :my-action #'(lambda (self restaurant)
                  (say (waiter restaurant) "~%~a" (random-pick smoking-or-non))
                   (setf (expecting-input (waiter restaurant)) t)
)))

(defparameter seat-in-smoking (make-instance 'mystep
                :name "seat-in-smoking"
                :input-condition (wordc :nec '(smoking))
                :my-condition (orc (list 
                               (lambdac #'(lambda (restaurant mystep)
                                (prev-step-matches restaurant 
                                    '("what-section") 3)))
                              (wordc :nec '(smoking))))
                :my-action #'(lambda (self restaurant)
                    (say (waiter restaurant) 
                       "~%Here is a seat in the smoking section for you.")
)))

(defparameter seat-in-non-smoking (make-instance 'mystep
               :name "seat-in-non-smoking"
               :input-condition (notc (wordc :nec '(smoking)))
               :my-condition (orc (list
                          (lambdac #'(lambda (restaurant mystep)
                             (prev-step-matches restaurant 
                                     '("what-section") 3)))
                           (wordc :nec '(non-smoking))))
               :my-action #'(lambda (self restaurant)
                 (say (waiter restaurant) 
                  "~%Here is a seat in the non-smoking section for you."))
))

    (defparameter deliver-menu (make-instance 'mystep
                                  :name "deliver-menu"
                                  :my-condition
                                  (spscorec :sc 2
                                     :nec  (andc :nec 
                                              (list (orc (list 
                                                        (historyc 
                                                           "seat-in-smoking")
                                                         (historyc 
                                                         "seat-in-non-smoking"
                                                )))
                                                (notc (orc (list
                                                               (historyc 
                                                                "deliver-menu")
                                                                (historyc 
                                                                 "list-menu")
                                                               (historyc 
                                                                 "get-item"))))
                                                )))
                                  :my-action #'(lambda (self restaurant)
                                                  (say (waiter restaurant) 
                                                 "~%Here's the menu for you: ")
                                                  (print-menu restaurant))))

  (defparameter greeting (make-instance 'scenario 
           :name "simple greeting scenario" 
           :description "Say hi to Bob"
           :my-condition (lambdac #'(lambda (restaurant mystep)
                                ;test if we were the last scenario or not. 
                                (cond ((or (null (history (waiter restaurant)))
                                       (string-equal (name (last-scenario 
                                                        (waiter restaurant)))
                                                    "simple greeting scenario"
))
                                     (make-instance 'results 
                                                   :success t
                                                   :score 1))
				   (t (make-instance 'results
                                                     :success nil)))))
           :parent general-scenario
           :end-condition (andc :nec (list (orc (list
                                       (historyc "seat-in-smoking")
                                       (historyc "seat-in-non-smoking")))
                            (orc (list (historyc "deliver-menu")
                                       (historyc "list-menu")
                                  (historyc "get-item")
                                  (historyc "drink-order")
                                  (historyc "food-order")
                                  (historyc "order-scenario")))))
))
   
   (add-steps greeting (list hi fine too-bad what-section seat-in-smoking 
                             seat-in-non-smoking deliver-menu))






